unit CDEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCDEdit = class(TEdit)
  private
    { Dclarations prives }
    FTextAlign: TAlignment;
    FOnlyNumbers: Boolean;
    procedure SetOnlyNumbers(Value: Boolean);
    procedure SetTextAlign(Value: TAlignment);
  protected
    { Dclarations protges }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Dclarations publiques }
    constructor Create(AOwner: TComponent); override;
  published
    { Dclarations publies }
    property OnlyNumbers: Boolean read FOnlyNumbers write SetOnlyNumbers;
    property TextAlignment: TAlignment read FTextAlign write SetTextAlign;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Exemples', [TCDEdit]);
end;

{ TCDEdit }

constructor TCDEdit.Create(AOwner: TComponent);
begin
  inherited;
  FTextAlign := taLeftJustify;
  FOnlyNumbers := FALSE;
end;

procedure TCDEdit.CreateParams(var Params: TCreateParams);
const
	Alignments: array[TAlignment] of Word = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
	inherited CreateParams(Params);
	Params.Style := Params.Style or Alignments[TextAlignment];
  if OnlyNumbers then
    Params.Style := Params.Style or ES_NUMBER
end;

procedure TCDEdit.SetOnlyNumbers(Value: Boolean);
begin
  if FOnlyNumbers <> Value then begin
    FOnlyNumbers := Value;
    RecreateWnd;
  end;
end;

procedure TCDEdit.SetTextAlign(Value: TAlignment);
begin
  if FTextAlign <> Value then begin
    FTextAlign := Value;
    RecreateWnd;
  end;
end;

end.
